using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Dependency Property
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region    Ӽ - InfoBadgeOpacityProperty

        /// <summary>
        ///    Ӽ
        /// </summary>
        public static readonly DependencyProperty InfoBadgeOpacityProperty = DependencyProperty.Register
        (
            "InfoBadgeOpacity",
            typeof(double),
            typeof(MainPage),
            new PropertyMetadata(0.0)
        );

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region    - InfoBadgeOpacity

        /// <summary>
        ///   
        /// </summary>
        public double InfoBadgeOpacity
        {
            get
            {
                return (double)GetValue(InfoBadgeOpacityProperty);
            }
            set
            {
                SetValue(InfoBadgeOpacityProperty, value);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            this.infoBadgeOpacityToggleSwitch.Toggled += infoBadgeOpacityToggleSwitch_Toggled;
            this.displayModeComboBox.SelectionChanged += displayModeComboBox_SelectionChanged;

            this.infoBadgeOpacityToggleSwitch.IsOn = true;
            this.displayModeComboBox.SelectedValue = "LeftExpanded";
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region InfoBadge Opacity  ġ ۽ óϱ - infoBadgeOpacityToggleSwitch_Toggled(sender, e)

        /// <summary>
        /// InfoBadge Opacity  ġ ۽ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void infoBadgeOpacityToggleSwitch_Toggled(object sender, RoutedEventArgs e)
        {
            InfoBadgeOpacity = (InfoBadgeOpacity == 0.0) ? 1.0 : 0.0;
        }

        #endregion
        #region Display Mode ޺ ڽ   óϱ - displayModeComboBox_SelectionChanged(sender, e)

        /// <summary>
        /// Display Mode ޺ ڽ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        public void displayModeComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            string displayMode = e.AddedItems[0].ToString();

            switch(displayMode)
            {
                case "LeftExpanded" :

                    this.navigationView.PaneDisplayMode = NavigationViewPaneDisplayMode.Left;
                    this.navigationView.IsPaneOpen      = true;

                    break;

                case "LeftCompact" :

                    this.navigationView.PaneDisplayMode = NavigationViewPaneDisplayMode.LeftCompact;
                    this.navigationView.IsPaneOpen      = false;

                    break;

                case "Top" :

                    this.navigationView.PaneDisplayMode = NavigationViewPaneDisplayMode.Top;
                    this.navigationView.IsPaneOpen      = true;

                    break;
            }
        }

        #endregion
    }
}